require "json"
require "uuid"
require "uuid/json"


class Library::Book

	property id              : UUID
	property title           : String
	property description     : String?
	property added_time      : Time
	property image_url      : String?
	property authors           : Array(String)

	def initialize(
		@title                 ,
		@added_time            = Time.local 
		@id                    = UUID.random
		@image_url             = nil,
		@description           = nil
	)
	end
end
